#!/usr/local/bin/python

import cgi
import math
import datetime

gunClock = []
clockSize = 10
centerX = 0;
centerY = 0;
gunmanX = 5;
gunmanY = 8;
inuX = 10;
inuY = 10;

class Cast:
  def __init__(self, image):
    self.image = image
  
  def display(self, x, y):
    global gunClock
    _x = int((x * 2) - ( len(self.image[0]) / 2 ))
    _y = int(y - ( len(self.image) /2 ))
    for i in range (0, len(self.image)):
      for j in range (0, len(self.image[i])):
        c = self.image[i][j]
        if c != "*" and (_x + j)>=0 and (_y + i) >=0 :

          tmp = gunClock[_y + i]
          tmp_list = list(tmp)
          tmp_list[_x + j] = c
          gunClock[_y + i] = "".join(tmp_list)

def initGunClock(gunClockSize):
  global gunClock
  global clockSize
  global centerX
  global centerY
  clockSize = gunClockSize
  centerX = int(clockSize / 2);
  centerY = int(clockSize / 2);

  for i in range(0, clockSize):
    gunClock.append(" "*clockSize*2)

def getTime():
  now = datetime.datetime.now()    
  return (now.hour, now.minute, now.second)

def wakuDisplay(waku):
  global gunClock, clockSize, centerX, centerX
  for i in range(0,360,30):
    if ( i % 90 == 0 ):
      continue

    radian = ( i * 2 * math.pi ) / 360
    wakuXdiff = clockSize/2 * math.cos(radian)
    wakuYdiff = clockSize/2 * math.sin(radian)

    if ( wakuXdiff >= 0 ) :
      wakuX = centerX + math.floor(wakuXdiff)
    else:
      wakuX = centerX + math.ceil(wakuXdiff)

    if ( wakuYdiff >= 0 ) :
      wakuY = centerY + math.floor(wakuYdiff)
    else:
      wakuY = centerY + math.ceil(wakuYdiff)

#    print "%s %s" % (wakuX , wakuY)

    waku.display(wakuX, wakuY)

def numDisplay(num3, num6, num9, num12):
  global clockSize, centerX, centerY
  num3.display(clockSize - 1, centerY)
  num6.display(centerX, clockSize - 1)
  num9.display(0, centerY)
  num12.display(centerX, 0)

def longHandDisplay(longHand):
  global centerX, centerY, inuX, inuY
  for i in range(0,clockSize*2/3/2):
    longHandX = centerX + ( ( (inuX - centerX) * i ) / (clockSize*2/3/2) )
    longHandY = centerY + ( ( (inuY - centerY) * i ) / (clockSize*2/3/2) )
    longHand.display(longHandX, longHandY)

def shortHandDisplay(shortHand):
  global centerX, centerY, gunmanX, gunmanY
  for i in range(0,clockSize*5/6/2):
    shortHandX = centerX + ( ( (gunmanX - centerX) * i ) / (clockSize*5/6/2) )
    shortHandY = centerY + ( ( (gunmanY - centerY) * i ) / (clockSize*5/6/2) )
    shortHand.display(shortHandX, shortHandY)

def digitalTimeDisplay(hour, minute, second):
  digitalTime = Cast ([
#    "__________",
#    "|" + ("%02d:%02d:%02d" % (hour, minute, second) ) + "|" ,
#    "~~~~~~~~~~"
    "_______",
    "|" + ("%02d:%02d" % (hour, minute) ) + "|" ,
    "~~~~~~~"
  ])
  digitalTimeRadian = digitalRadian(hour,minute,second)
  digitalTime.display(
    centerX + (math.cos(digitalTimeRadian) * clockSize/2 * 1/2),
    centerY - (math.sin(digitalTimeRadian) * clockSize/2 * 1/2)
  )

def digitalRadian(h, m, s):
  hRadian = hourToRadian(h, m)
  mRadian = minuteToRadian(m, s)
  aveRadian = (hRadian + mRadian) / 2
  if ( ( (hRadian > mRadian) and (hRadian - mRadian < math.pi) )
    or ( (mRadian > hRadian) and (mRadian - hRadian < math.pi) ) ) :
    return aveRadian + math.pi
  else :
    return aveRadian
 
def hourToRadian(h, m):
  return math.pi * ( 90.0 - ( (h%12) + m/60 ) * 30 ) / 180.0

def minuteToRadian(m, s):
  return math.pi * ( 90.0 - ( m + s/60 ) * 6 ) / 180.0

def arrayToString(gunClock):
  retstr = "" 
  for i in range(0, len(gunClock)):
#    retstr += ("%02i" % i) + ": \'"  + gunClock[i] + "\'\n"
     retstr += gunClock[i] + "\n"
  return retstr


gunman = Cast([
  "** __ *", 
  " _|__|_",
  "b (@@) ",
  " V|~~|>",
  "* //T| "
])

inu = Cast([
  "__AA  **",
  "| 6 |__P",
  "~~|    l",
  "*/_/~l_l"
])

form = cgi.FieldStorage()
if ( "clockSize" in form ) :
  clockSize = int(form["clockSize"].value)
else :
  clockSize = 20 

initGunClock(clockSize)

(hour, minute, second) = getTime()

gunmanX = centerX + math.cos(hourToRadian(hour, minute)) * (clockSize * 2/3/2)
gunmanY = centerY - math.sin(hourToRadian(hour, minute)) * (clockSize * 2/3/2)
inuX = centerX + math.cos(minuteToRadian(minute, second)) * (clockSize * 4/5/2) 
inuY = centerY - math.sin(minuteToRadian(minute, second)) * (clockSize * 4/5/2) 


wakuDisplay( Cast(["+"]) )
numDisplay( Cast(["3"]), Cast(["6"]), Cast(["9"]), Cast(["12"]) )
longHandDisplay( Cast(["##"]) )
shortHandDisplay( Cast(["::"]) )

inu.display(inuX, inuY)
gunman.display(gunmanX, gunmanY)
digitalTimeDisplay(hour, minute, second)

html = '''Content-Type: text/html

<html>
<head>
  <META HTTP-EQUIV='refresh' CONTENT='60;URL=GunClock.py.cgi'>
  <title>GunClock (python)</title>
</head>
<body>
<h1>GunClock (python)</h1>
<hr>

<form method="POST" action="GunClock.py.cgi">
clock size : 
<input type="text"
 name="clockSize"
 value="%d"
 size="4">
<input type="submit" value="display">
</form>
<pre>
%s
</pre>
<hr>
<textarea cols=80 rows=80>
%s
</textarea>
<hr>
</body>
</html>
'''

gunClockString = arrayToString(gunClock)

pythonSrc = open("GunClock.py.cgi", "r")
pythonSrcList = ""
for line in pythonSrc:
  pythonSrcList += line.replace("&","&amp;").replace("<","&lt;")
pythonSrc.close()

print html % (clockSize, gunClockString, pythonSrcList)
